<template>
    <div class="page-table scrollable only-y">
        <div class="">
            <h1>Account</h1>
            <!--<h4>for a better experience on Mac OS during horizontal scroll is prefered disable the "Swipe between pages" option </h4>-->
            <el-breadcrumb separator="/">
                <el-breadcrumb-item :to="{ path: '/' }"><i class="mdi mdi-home-outline"></i></el-breadcrumb-item>
                <el-breadcrumb-item :to="{ path: '/accounts' }">Account</el-breadcrumb-item>
                <el-breadcrumb-item>{{detail.name.length < 50 ? detail.name : detail.name.substring(0,45)+'...'}}</el-breadcrumb-item>

            </el-breadcrumb>
        </div>
        <br/>
        <el-card v-if="isContentFound" style="text-align: left; margin: 20px 0"  v-loading="loading">
            <not-found></not-found>
        </el-card>
        <div v-else>
            <el-card class="box-card" style="text-align: left; position: relative"  v-loading="loading">
                <div class="card-inner">
                    <div class="profile-card">
                        <div class="header-edit">
                            <el-button @click="onEdit(detail.id, $event)" title="Edit account"
                            class="btn-edit" icon="el-icon-edit" circle type="primary"></el-button>
                        </div>

                        <div class="left-card" style="text-align: center">
                            <div class="img-profile">
                                <img
                                        class="img-full-detail"
                                        @click="showAvatar(detail.avatar_url, $event)"
                                        :src="(detail.avatar_url)? detail.avatar_url: $store.state.avtHolder">
                            </div>
                            <h2 style="margin-bottom: 0">{{detail.name}} </h2>



                        </div>
                        <div class="right-card">
                            <div class="right-card-inner">
                                <el-row :gutter="20" style="width: 100%">
                                    <el-col :span="24">
                                        <div class="">
                                            <el-tag v-for="role in detail.roles"
                                                    class="font-weight-800"
                                                    >
                                                {{role.name}}
                                            </el-tag>
                                        </div>
                                    </el-col>
                                    <el-col :span="24">
                                        <div class="info-item" v-if="detail.id"  title="Accouny ID">
                                            <i class="mdi mdi-account-key"></i><span> {{detail.id}}</span>
                                        </div>
                                    </el-col>
                                    <el-col :span="24">
                                        <div class="info-item" v-if="detail.username" title="Email">
                                            <i class="mdi mdi-email-outline"></i><span> {{detail.username}} </span>
                                        </div>
                                    </el-col>
                                </el-row>
                                <el-row :gutter="20" style="width: 100%">
                                    <el-col :span="24">
                                        <div class="info-item" v-if="detail.id"  title="Create at">
                                            <i class="mdi mdi-calendar-clock"></i><span> {{ detail.created_at | moment("DD-MM-YYYY HH:mm:ss") }}</span>
                                        </div>
                                    </el-col>
                                </el-row>
                                <br/>
                                <br/>
                            </div>

                        </div>
                    </div>


                </div>
                 <div class="profile-bottom">
                    <div style="text-align: left"  v-if="$store.state && $store.state.profile ? $store.state.profile.userName !== detail.username : fasle">
                        <el-button class="text-red ml-20"
                                    type="text"
                                   @click="onRemove(detail.id, $event)">Delete
                        </el-button>
                    </div>
                </div>
            </el-card >

        </div>
    </div>
</template>

<script>
    import {
        account as accountApi,

    } from '~/services/apis/index'
    import NotFound from '../ContentNotFound'
    export default {
        name: 'AccountDetail',
        components: {
            NotFound,
        },
        data() {
            return {
                detail: {
                    id: "",
                    created_at: "",
                    updated_at: "",
                    name: "",
                    username: "",
                },
                loading: true,
                tableLoading: true,
                isContentFound: false,
                dialogvisible: false,
                dialogFormvisible: false,
            }
        },
        methods: {
            getDetail(){
                this.loading = true;
                if(!this.$route || !this.$route.params.id) return;
                accountApi.getAccount(this.$route.params.id)
                .then((res) => {

                    this.initDetail(res.data.data)
                    this.isContentFound = false;
                    this.loading = false;
                })
                .catch((err) => {
                    this.isContentFound = true;
                    this.loading = false;
                })

            },

            showDetail(row){
                var selection = window.getSelection();
                if(selection.toString().length !== 0) return;

                var id = row.id;
                this.$router.push({ name: 'account_detail', params: { id } });
            },
            initDetail(data){
                if(!data) return;
                this.detail = {
                    id: data.id,
                    name: data.name,
                    username: data.username,
                    created_at: data.created_at,
                    roles: data.roles

                }
            },

            showAvatar(url,event) {
                if (event) {
                    event.preventDefault();
                    event.stopPropagation();
                }

                if(!url) return;
                this.imageUrl = url;
                this.dialogvisible = true;
            },
              onRemove(id, event){
                // this.loading = true;
                if(event){
                    event.preventDefault();
                    event.stopPropagation();
                }

                this.$confirm('Are you sure you want to delete this account?', 'Warning', {
                    confirmButtonText: 'Yes',
                    cancelButtonText: 'Cancel',
                    type: 'warning',
                    center: true
                }).then(() => {
                    accountApi.removeAccount(id)
                    .then((res)=>{
                      if(res.status === 204) {
                          this.$notify({
                              title: 'Success',
                            message: 'Delete account successfully!',
                            type: 'success'
                        });

                        this.loading = false;
                        this.$router.push({ name: 'account'});
                        // this.getListData();
                      }
                    })
                    .catch(()=>{
                        this.$notify.error({
                            title: 'Error',
                            message: 'Cannot delete account'
                        });
                        this.loading = false;
                    })
                }).catch((err) => {
                    console.log(err);
                    this.loading = false;
                });
            },

            /*Edit account */
             onEdit(id, event) {
                event.preventDefault();
                event.stopPropagation();
            this.$router.push({ name: 'account_edit'});
            },

        },
        mounted(){
            this.getDetail()
        }
    }
</script>

<style lang="scss">
    .btn-verify{
        position: absolute;
        top: 10px;
        right: 10px;

    }

    .profile-card{
        &>div{
            display: inline-block;
            vertical-align: top;

        }
        .left-card{
            width: 250px;
            padding: 20px 0;
        }
        .right-card{
            width: calc(100% - 250px);
            .right-card-inner{
                padding: 20px;

            }

        }
    }
    .btn-eye{
        padding: 1px 6px;
    }

    .profile-bottom{
        width: 100%;
        padding-top: 25px;
        border-top: 1px solid #f1f1f1;
    }

    .header-edit {
        position: absolute;
        right: 20px;
        z-index: 10;
    }

    .add-honey-button {
        float: right;
    }
</style>
